##// END OF EJS Templates
Updates due to modifs on raspberryPi /linux github...
vidal -
r774:33d3a3b5ebfc
parent child
Show More
1 NO CONTENT: new file 100644, binary diff hidden
NO CONTENT: new file 100644, binary diff hidden
@@ -1,54 +1,54
1 #
1 #
2 # Setup APT repositories
2 # Setup APT repositories
3 #
3 #
4
4
5 # Load utility functions
5 # Load utility functions
6 . ./functions.sh
6 . ./functions.sh
7
7
8 # Install and setup APT proxy configuration
8 # Install and setup APT proxy configuration
9 if [ -z "$APT_PROXY" ] ; then
9 if [ -z "$APT_PROXY" ] ; then
10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
12 fi
12 fi
13
13
14 # Install APT sources.list
14 # Install APT sources.list
15 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
15 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
16
16
17 # Use specified APT server and release
17 # Use specified APT server and release
18 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
18 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
19
19
20 #Fix for changing path for security updates in testing
20 #Fix for changing path for security updates in oldstable / buster
21 if [ "$RELEASE" = "testing" ] ; then
21 if [ "$RELEASE" = "oldstable" ] || [ "$RELEASE" = "buster " ] ; then
22 sed -i "s,buster\\/updates,testing-security," "${ETC_DIR}/apt/sources.list"
22 sed -i "s:bullseye-security:${RELEASE}\\/updates:" "${ETC_DIR}/apt/sources.list"
23 sed -i "s/ buster/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
23 sed -i "s:security.debian.org/debian-security:security.debian.org:" "${ETC_DIR}/apt/sources.list"
24 fi
24 fi
25
25
26 if [ "$ENABLE_NONFREE" = "true" ] ; then
26 if [ "$ENABLE_NONFREE" = "true" ] ; then
27 sed -i "s,main contrib,main contrib non-free," "${ETC_DIR}/apt/sources.list"
27 sed -i "s,main contrib,main contrib non-free," "${ETC_DIR}/apt/sources.list"
28 fi
28 fi
29
29
30 if [ -z "$RELEASE" ] ; then
30 if [ -z "$RELEASE" ] ; then
31 # Change release in sources list
31 # Change release in sources list
32 sed -i "s/ buster/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
32 sed -i "s/ bullseye/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
33 fi
33 fi
34
34
35 # Upgrade package index and update all installed packages and changed dependencies
35 # Upgrade package index and update all installed packages and changed dependencies
36 chroot_exec apt-get -qq -y update
36 chroot_exec apt-get -qq -y update
37 chroot_exec apt-get -qq -y -u dist-upgrade
37 chroot_exec apt-get -qq -y -u dist-upgrade
38
38
39 # Install additional packages
39 # Install additional packages
40 if [ "$APT_INCLUDES_LATE" ] ; then
40 if [ "$APT_INCLUDES_LATE" ] ; then
41 chroot_exec apt-get -qq -y install $(echo "$APT_INCLUDES_LATE" |tr , ' ')
41 chroot_exec apt-get -qq -y install $(echo "$APT_INCLUDES_LATE" |tr , ' ')
42 fi
42 fi
43
43
44 # Install Debian custom packages
44 # Install Debian custom packages
45 if [ -d packages ] ; then
45 if [ -d packages ] ; then
46 for package in packages/*.deb ; do
46 for package in packages/*.deb ; do
47 cp "$package" "${R}"/tmp
47 cp "$package" "${R}"/tmp
48 chroot_exec dpkg --unpack /tmp/"$(basename "$package")"
48 chroot_exec dpkg --unpack /tmp/"$(basename "$package")"
49 done
49 done
50 fi
50 fi
51
51
52 chroot_exec apt-get -qq -y -f install
52 chroot_exec apt-get -qq -y -f install
53
53
54 chroot_exec apt-get -qq -y check
54 chroot_exec apt-get -qq -y check
@@ -1,8 +1,8
1 deb http://ftp.debian.org/debian buster main contrib
1 deb http://debian.proxad.net/debian/ bullseye main contrib
2 #deb-src http://ftp.debian.org/debian buster main contrib
2 #deb-src http://ftp.debian.org/debian bullseye main contrib
3
3
4 deb http://ftp.debian.org/debian/ buster-updates main contrib
4 deb http://debian.proxad.net/debian/ bullseye-updates main contrib
5 #deb-src http://ftp.debian.org/debian/ buster-updates main contrib
5 #deb-src http://ftp.debian.org/debian/ bullseye-updates main contrib
6
6
7 deb http://security.debian.org/ buster/updates main contrib
7 deb http://security.debian.org/debian-security bullseye-security main contrib
8 #deb-src http://security.debian.org/ buster/updates main contrib
8 #deb-src http://security.debian.org/ bullseye/updates main contrib
@@ -1,122 +1,122
1 # This file contains utility functions used by rpi23-gen-image.sh
1 # This file contains utility functions used by rpi23-gen-image.sh
2
2
3 cleanup (){
3 cleanup (){
4 set +x
4 set +x
5 set +e
5 set +e
6
6
7 # Remove exports from nexmon
7 # Remove exports from nexmon
8 unset KERNEL
8 unset KERNEL
9 unset ARCH
9 unset ARCH
10 unset SUBARCH
10 unset SUBARCH
11 unset CCPLUGIN
11 unset CCPLUGIN
12 unset ZLIBFLATE
12 unset ZLIBFLATE
13 unset Q
13 unset Q
14 unset NEXMON_SETUP_ENV
14 unset NEXMON_SETUP_ENV
15 unset HOSTUNAME
15 unset HOSTUNAME
16 unset PLATFORMUNAME
16 unset PLATFORMUNAME
17
17
18 # Identify and kill all processes still using files
18 # Identify and kill all processes still using files
19 echo "killing processes using mount point ..."
19 echo "killing processes using mount point ..."
20 fuser -k "${R}"
20 fuser -k "${R}"
21 sleep 3
21 sleep 3
22 fuser -9 -k -v "${R}"
22 fuser -9 -k -v "${R}"
23
23
24 # Clean up temporary .password file
24 # Clean up temporary .password file
25 if [ -r ".password" ] ; then
25 if [ -r ".password" ] ; then
26 shred -zu .password
26 shred -zu .password
27 fi
27 fi
28
28
29 # Clean up all temporary mount points
29 # Clean up all temporary mount points
30 echo "removing temporary mount points ..."
30 echo "removing temporary mount points ..."
31 umount -l "${R}/proc" 2> /dev/null
31 umount -l "${R}/proc" 2> /dev/null
32 umount -l "${R}/sys" 2> /dev/null
32 umount -l "${R}/sys" 2> /dev/null
33 umount -l "${R}/dev/pts" 2> /dev/null
33 umount -l "${R}/dev/pts" 2> /dev/null
34 umount "$BUILDDIR/mount/boot/firmware" 2> /dev/null
34 umount "$BUILDDIR/mount/boot/firmware" 2> /dev/null
35 umount "$BUILDDIR/mount" 2> /dev/null
35 umount "$BUILDDIR/mount" 2> /dev/null
36 cryptsetup close "${CRYPTFS_MAPPING}" 2> /dev/null
36 cryptsetup close "${CRYPTFS_MAPPING}" 2> /dev/null
37 losetup -d "$ROOT_LOOP" 2> /dev/null
37 losetup -d "$ROOT_LOOP" 2> /dev/null
38 losetup -d "$FRMW_LOOP" 2> /dev/null
38 losetup -d "$FRMW_LOOP" 2> /dev/null
39 trap - 0 1 2 3 6
39 trap - 0 1 2 3 6
40 }
40 }
41
41
42 chroot_exec() {
42 chroot_exec() {
43 # Exec command in chroot
43 # Exec command in chroot
44 LANG=C LC_ALL=C DEBIAN_FRONTEND=noninteractive chroot "${R}" "$@"
44 LANG=C LC_ALL=C DEBIAN_FRONTEND=noninteractive chroot "${R}" "$@"
45 }
45 }
46
46
47 as_nobody() {
47 as_nobody() {
48 # Exec command as user nobody
48 # Exec command as user nobody
49 sudo -E -u nobody LANG=C LC_ALL=C "$@"
49 sudo -E -u nobody LANG=C LC_ALL=C "$@"
50 }
50 }
51
51
52 install_readonly() {
52 install_readonly() {
53 # Install file with user read-only permissions
53 # Install file with user read-only permissions
54 install -o root -g root -m 644 "$@"
54 install -o root -g root -m 644 "$@"
55 }
55 }
56
56
57 install_exec() {
57 install_exec() {
58 # Install file with root exec permissions
58 # Install file with root exec permissions
59 install -o root -g root -m 744 "$@"
59 install -o root -g root -m 744 "$@"
60 }
60 }
61
61
62 use_template () {
62 use_template () {
63 # Test if configuration template file exists
63 # Test if configuration template file exists
64 if [ ! -r "./templates/${CONFIG_TEMPLATE}" ] ; then
64 if [ ! -r "./templates/${CONFIG_TEMPLATE}" ] ; then
65 echo "error: configuration template ${CONFIG_TEMPLATE} not found"
65 echo "error: configuration template ${CONFIG_TEMPLATE} not found"
66 exit 1
66 exit 1
67 fi
67 fi
68
68
69 # Load template configuration parameters
69 # Load template configuration parameters
70 . "./templates/${CONFIG_TEMPLATE}"
70 . "./templates/${CONFIG_TEMPLATE}"
71 }
71 }
72
72
73 chroot_install_cc() {
73 chroot_install_cc() {
74 # Install c/c++ build environment inside the chroot
74 # Install c/c++ build environment inside the chroot
75 if [ -z "${COMPILER_PACKAGES}" ] ; then
75 if [ -z "${COMPILER_PACKAGES}" ] ; then
76 COMPILER_PACKAGES=$(chroot_exec apt-get -s install g++ make bc | grep "^Inst " | awk -v ORS=" " '{ print $2 }')
76 COMPILER_PACKAGES=$(chroot_exec apt-get -s install g++ make bc | grep "^Inst " | awk -v ORS=" " '{ print $2 }')
77
77
78
78
79 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
79 if [ "$RELEASE" = "bookworm" ] || [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
80 chroot_exec apt-get -q -y --no-install-recommends install ${COMPILER_PACKAGES}
80 chroot_exec apt-get -q -y --no-install-recommends install ${COMPILER_PACKAGES}
81 elif [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
81 elif [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] || [ "$RELEASE" = "bookworm" ]; then
82 chroot_exec apt-get -q -y --allow-unauthenticated --no-install-recommends install ${COMPILER_PACKAGES}
82 chroot_exec apt-get -q -y --allow-unauthenticated --no-install-recommends install ${COMPILER_PACKAGES}
83 fi
83 fi
84
84
85 fi
85 fi
86 }
86 }
87
87
88 chroot_remove_cc() {
88 chroot_remove_cc() {
89 # Remove c/c++ build environment from the chroot
89 # Remove c/c++ build environment from the chroot
90 if [ -n "${COMPILER_PACKAGES}" ] ; then
90 if [ -n "${COMPILER_PACKAGES}" ] ; then
91 chroot_exec apt-get -qq -y --auto-remove purge ${COMPILER_PACKAGES}
91 chroot_exec apt-get -qq -y --auto-remove purge ${COMPILER_PACKAGES}
92 COMPILER_PACKAGES=""
92 COMPILER_PACKAGES=""
93 fi
93 fi
94 }
94 }
95
95
96 # https://serverfault.com/a/682849 - converts e.g. /24 to 255.255.255.0
96 # https://serverfault.com/a/682849 - converts e.g. /24 to 255.255.255.0
97 cdr2mask ()
97 cdr2mask ()
98 {
98 {
99 # Number of args to shift, 255..255, first non-255 byte, zeroes
99 # Number of args to shift, 255..255, first non-255 byte, zeroes
100 set -- $(( 5 - ($1 / 8) )) 255 255 255 255 $(( (255 << (8 - ($1 % 8))) & 255 )) 0 0 0
100 set -- $(( 5 - ($1 / 8) )) 255 255 255 255 $(( (255 << (8 - ($1 % 8))) & 255 )) 0 0 0
101 [ $1 -gt 1 ] && shift $1 || shift
101 [ $1 -gt 1 ] && shift $1 || shift
102 echo ${1-0}.${2-0}.${3-0}.${4-0}
102 echo ${1-0}.${2-0}.${3-0}.${4-0}
103 }
103 }
104
104
105 # GPL v2.0 - #https://github.com/sakaki-/bcmrpi3-kernel-bis/blob/master/conform_config.sh
105 # GPL v2.0 - #https://github.com/sakaki-/bcmrpi3-kernel-bis/blob/master/conform_config.sh
106 set_kernel_config() {
106 set_kernel_config() {
107 # flag as $1, value to set as $2, config must exist at "./.config"
107 # flag as $1, value to set as $2, config must exist at "./.config"
108 TGT="CONFIG_${1#CONFIG_}"
108 TGT="CONFIG_${1#CONFIG_}"
109 REP="${2}"
109 REP="${2}"
110 if grep -q "^${TGT}[^_]" .config; then
110 if grep -q "^${TGT}[^_]" .config; then
111 sed -i "s/^\(${TGT}=.*\|# ${TGT} is not set\)/${TGT}=${REP}/" .config
111 sed -i "s/^\(${TGT}=.*\|# ${TGT} is not set\)/${TGT}=${REP}/" .config
112 else
112 else
113 echo "${TGT}"="${2}" >> .config
113 echo "${TGT}"="${2}" >> .config
114 fi
114 fi
115 }
115 }
116
116
117 # unset kernel config parameter
117 # unset kernel config parameter
118 unset_kernel_config() {
118 unset_kernel_config() {
119 # unsets flag with the value of $1, config must exist at "./.config"
119 # unsets flag with the value of $1, config must exist at "./.config"
120 TGT="CONFIG_${1#CONFIG_}"
120 TGT="CONFIG_${1#CONFIG_}"
121 sed -i "s/^${TGT}=.*/# ${TGT} is not set/" .config
121 sed -i "s/^${TGT}=.*/# ${TGT} is not set/" .config
122 }
122 }
@@ -1,924 +1,926
1 #!/bin/bash
1 #!/bin/bash
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "buster" and "bullseye" bootstrap script for Raspberry Pi
5 # Advanced Debian "bullseye" and "bookworm" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration defaults to 3P
43 RPI_MODEL=${RPI_MODEL:=3P}
43 RPI_MODEL=${RPI_MODEL:=3P}
44
44
45 # Debian release
45 # Debian release defaults to bullseye
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=bullseye}
47 if [ $RELEASE = "bullseye" ] ; then
47 if [ "$RELEASE" = "bookworm" ] ; then
48 RELEASE=testing
48 RELEASE=testing
49 fi
49 fi
50 echo "Debian release value used : " $RELEASE
50
51
51 # Kernel Branch
52 # Kernel Branch
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53
54
54 # URLs
55 # URLs
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 #WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
59 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://raw.githubusercontent.com/RPi-Distro/firmware-nonfree/bullseye/debian/config/brcm80211/brcm}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
60 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
61 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
62 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
63 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
64 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
65 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64
66
65 # Kernel deb packages for 32bit kernel
67 # Kernel deb packages for 32bit kernel
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
68 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
69 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
70 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
71 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 # Default precompiled 64bit kernel
72 # Default precompiled 64bit kernel
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
73 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
74 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
75 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
76 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
77 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 # Generic
78 # Generic
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
79 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
80 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
81 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
82 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81
83
82 # Build directories
84 # Build directories
83 WORKDIR=$(pwd)
85 WORKDIR=$(pwd)
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
86 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 BUILDDIR="${BASEDIR}/build"
87 BUILDDIR="${BASEDIR}/build"
86
88
87 # Chroot directories
89 # Chroot directories
88 R="${BUILDDIR}/chroot"
90 R="${BUILDDIR}/chroot"
89 ETC_DIR="${R}/etc"
91 ETC_DIR="${R}/etc"
90 LIB_DIR="${R}/lib"
92 LIB_DIR="${R}/lib"
91 BOOT_DIR="${R}/boot/firmware"
93 BOOT_DIR="${R}/boot/firmware"
92 KERNEL_DIR="${R}/usr/src/linux"
94 KERNEL_DIR="${R}/usr/src/linux"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
95 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
96 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95
97
96 # APT settings
98 # APT settings
97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
99 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 APT_PROXY=${APT_PROXY:=""}
100 APT_PROXY=${APT_PROXY:=""}
99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
101 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 # Packages required in the chroot build environment
102 # Packages required in the chroot build environment
101 APT_INCLUDES=${APT_INCLUDES:=""}
103 APT_INCLUDES=${APT_INCLUDES:=""}
102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
104 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 # Packages to exclude from chroot build environment
105 # Packages to exclude from chroot build environment
104 APT_EXCLUDES=${APT_EXCLUDES:=""}
106 APT_EXCLUDES=${APT_EXCLUDES:=""}
105
107
106 # General settings
108 # General settings
107 SET_ARCH=${SET_ARCH:=32}
109 SET_ARCH=${SET_ARCH:=32}
108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
110 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
111 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
112 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 EXPANDROOT=${EXPANDROOT:=true}
113 EXPANDROOT=${EXPANDROOT:=true}
112
114
113 ENABLE_ROOT=${ENABLE_ROOT:=false}
115 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
116 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 ENABLE_USER=${ENABLE_USER:=true}
117 ENABLE_USER=${ENABLE_USER:=true}
116 USER_NAME=${USER_NAME:="pi"}
118 USER_NAME=${USER_NAME:="pi"}
117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
119 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118
120
119 # Keyboard settings
121 # Keyboard settings
120 XKB_MODEL=${XKB_MODEL:=""}
122 XKB_MODEL=${XKB_MODEL:=""}
121 XKB_LAYOUT=${XKB_LAYOUT:=""}
123 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 XKB_VARIANT=${XKB_VARIANT:=""}
124 XKB_VARIANT=${XKB_VARIANT:=""}
123 XKB_OPTIONS=${XKB_OPTIONS:=""}
125 XKB_OPTIONS=${XKB_OPTIONS:=""}
124
126
125 # Networking settings:
127 # Networking settings:
126 ENABLE_IPV6=${ENABLE_IPV6:=true}
128 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
129 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
130 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
131 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
132 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131
133
132 # Network settings (DHCP)
134 # Network settings (DHCP)
133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
135 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
136 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135
137
136 # Network settings (static)
138 # Network settings (static)
137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
139 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
140 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
141 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
142 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
143 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
144 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
145 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144
146
145 # Networking settings (WIFI):
147 # Networking settings (WIFI):
146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
148 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
149 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148
150
149 # Network settings (static)
151 # Network settings (static)
150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
152 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
153 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
154 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
155 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
156 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
157 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
158 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157
159
158 # Feature settings
160 # Feature settings
159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
162 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
163 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
164 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 ENABLE_TURBO=${ENABLE_TURBO:=false}
165 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 ENABLE_I2C=${ENABLE_I2C:=false}
166 ENABLE_I2C=${ENABLE_I2C:=false}
165 ENABLE_SPI=${ENABLE_SPI:=false}
167 ENABLE_SPI=${ENABLE_SPI:=false}
166
168
167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
169 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
170 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 ENABLE_SOUND=${ENABLE_SOUND:=false}
171 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
172 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
173 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 ENABLE_XORG=${ENABLE_XORG:=false}
174 ENABLE_XORG=${ENABLE_XORG:=false}
173 ENABLE_WM=${ENABLE_WM:=""}
175 ENABLE_WM=${ENABLE_WM:=""}
174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
176 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
177 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 ENABLE_LOGO=${ENABLE_LOGO:=true}
178 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
179 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
180 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179
181
180 # Advanced settings
182 # Advanced settings
181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
183 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
184 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 ENABLE_QEMU=${ENABLE_QEMU:=false}
185 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
186 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
187 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
188 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
189 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 ENABLE_DBUS=${ENABLE_DBUS:=true}
190 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
191 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
192 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
193 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
194 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
195 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 ENABLE_GR_ACCEL=${ENABLE_GR_ACCEL:=true}
196 ENABLE_GR_ACCEL=${ENABLE_GR_ACCEL:=true}
195 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
197 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
196 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
198 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
197 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
199 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
198 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
200 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
199 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
201 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
200
202
201 # SSH settings
203 # SSH settings
202 SSH_ENABLE=${SSH_ENABLE:=true}
204 SSH_ENABLE=${SSH_ENABLE:=true}
203 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
205 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
204 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
206 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
205 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
207 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
206 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
208 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
207 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
209 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
208
210
209 # Kernel compilation settings
211 # Kernel compilation settings
210 BUILD_KERNEL=${BUILD_KERNEL:=true}
212 BUILD_KERNEL=${BUILD_KERNEL:=true}
211 KERNEL_THREADS=${KERNEL_THREADS:=1}
213 KERNEL_THREADS=${KERNEL_THREADS:=1}
212 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
214 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
213 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
215 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
214 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
216 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
215 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
217 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
216 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
218 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
217 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
218 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
219 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
220 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
222 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
223 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 # Firmware directory: Blank if download from github
224 # Firmware directory: Blank if download from github
223 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
225 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
224 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
226 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
225 KERNEL_NF=${KERNEL_NF:=false}
227 KERNEL_NF=${KERNEL_NF:=false}
226 KERNEL_VIRT=${KERNEL_VIRT:=false}
228 KERNEL_VIRT=${KERNEL_VIRT:=false}
227 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
229 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
228 KERNEL_BPF=${KERNEL_BPF:=false}
230 KERNEL_BPF=${KERNEL_BPF:=false}
229 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
231 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
230 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
232 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
231 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
233 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
232 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
234 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
233 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
235 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
234
236
235 # Reduce disk usage settings
237 # Reduce disk usage settings
236 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
238 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
237 REDUCE_APT=${REDUCE_APT:=true}
239 REDUCE_APT=${REDUCE_APT:=true}
238 REDUCE_DOC=${REDUCE_DOC:=false}
240 REDUCE_DOC=${REDUCE_DOC:=false}
239 REDUCE_MAN=${REDUCE_MAN:=false}
241 REDUCE_MAN=${REDUCE_MAN:=false}
240 REDUCE_VIM=${REDUCE_VIM:=false}
242 REDUCE_VIM=${REDUCE_VIM:=false}
241 REDUCE_BASH=${REDUCE_BASH:=false}
243 REDUCE_BASH=${REDUCE_BASH:=false}
242 REDUCE_HWDB=${REDUCE_HWDB:=false}
244 REDUCE_HWDB=${REDUCE_HWDB:=false}
243 REDUCE_SSHD=${REDUCE_SSHD:=false}
245 REDUCE_SSHD=${REDUCE_SSHD:=false}
244 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
246 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
245 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
247 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
246
248
247 # Encrypted filesystem settings
249 # Encrypted filesystem settings
248 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
250 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
249 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
251 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
250 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
252 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
251 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
253 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
252 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
254 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
253 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
255 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
254 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
256 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
255 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
257 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
256 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
258 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
257 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
259 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
258
260
259 # Packages required for bootstrapping
261 # Packages required for bootstrapping
260 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
262 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
261 MISSING_PACKAGES=""
263 MISSING_PACKAGES=""
262
264
263 # Packages installed for c/c++ build environment in chroot (keep empty)
265 # Packages installed for c/c++ build environment in chroot (keep empty)
264 COMPILER_PACKAGES=""
266 COMPILER_PACKAGES=""
265
267
266 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
268 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
267 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
269 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
268 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
270 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
269 APT_PROXY=http://127.0.0.1:3142/
271 APT_PROXY=http://127.0.0.1:3142/
270 fi
272 fi
271
273
272 # Setup architecture specific settings
274 # Setup architecture specific settings
273 if [ -n "$SET_ARCH" ] ; then
275 if [ -n "$SET_ARCH" ] ; then
274 ## 64-bit configuration
276 ## 64-bit configuration
275 if [ "$SET_ARCH" = 64 ] ; then
277 if [ "$SET_ARCH" = 64 ] ; then
276 ### General 64-bit depended settings
278 ### General 64-bit depended settings
277 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
279 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
278 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
280 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
279 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
281 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
280
282
281 ### Raspberry Pi model specific settings
283 ### Raspberry Pi model specific settings
282 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
284 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
283 if [ "$RPI_MODEL" != 4 ] ; then
285 if [ "$RPI_MODEL" != 4 ] ; then
284 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
285 else
287 else
286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
287 fi
289 fi
288
290
289 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
291 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
290 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
292 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
291 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
293 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
292 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
294 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
293
295
294 else
296 else
295 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
297 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
296 exit 1
298 exit 1
297 fi
299 fi
298 fi
300 fi
299
301
300 ## 32-bit configuration
302 ## 32-bit configuration
301 if [ "$SET_ARCH" = 32 ] ; then
303 if [ "$SET_ARCH" = 32 ] ; then
302 ### General 32-bit dependend settings
304 ### General 32-bit dependend settings
303 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
305 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
304 KERNEL_ARCH=${KERNEL_ARCH:=arm}
306 KERNEL_ARCH=${KERNEL_ARCH:=arm}
305 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
307 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
306
308
307 ### Raspberry Pi (0-1P) model specific settings
309 ### Raspberry Pi (0-1P) model specific settings
308 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
310 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
310 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
312 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
311 RELEASE_ARCH=${RELEASE_ARCH:=armel}
313 RELEASE_ARCH=${RELEASE_ARCH:=armel}
312 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
314 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
313 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
315 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
314
316
315 if [ $ENABLE_XORG = true ] ; then
317 if [ $ENABLE_XORG = true ] ; then
316 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
318 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
317 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
319 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
318 read -r confirm
320 read -r confirm
319 if [ "$confirm" = "y" ] ; then
321 if [ "$confirm" = "y" ] ; then
320 $RELEASE = "stretch"
322 $RELEASE = "stretch"
321 fi
323 fi
322 fi
324 fi
323 fi
325 fi
324 fi
326 fi
325 ### Raspberry Pi (2-4) model specific settings
327 ### Raspberry Pi (2-4) model specific settings
326 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
328 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
327 if [ "$RPI_MODEL" != 4 ] ; then
329 if [ "$RPI_MODEL" != 4 ] ; then
328 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
330 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
329 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
331 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
330 else
332 else
331 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
333 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
332 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
334 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
333 fi
335 fi
334
336
335 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
337 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
336 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
338 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
337
339
338 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
340 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
339 fi
341 fi
340 fi
342 fi
341 # SET_ARCH not set
343 # SET_ARCH not set
342 else
344 else
343 echo "error: Please set '32' or '64' as value for SET_ARCH"
345 echo "error: Please set '32' or '64' as value for SET_ARCH"
344 exit 1
346 exit 1
345 fi
347 fi
346 # Device specific configuration and U-Boot configuration
348 # Device specific configuration and U-Boot configuration
347 case "$RPI_MODEL" in
349 case "$RPI_MODEL" in
348 0)
350 0)
349 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
351 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
350 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
352 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
351 ;;
353 ;;
352 1)
354 1)
353 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
355 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
354 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
356 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
355 ;;
357 ;;
356 1P)
358 1P)
357 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
359 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
358 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
360 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
359 ;;
361 ;;
360 2)
362 2)
361 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
363 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
362 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
364 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
363 ;;
365 ;;
364 3)
366 3)
365 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
367 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
366 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
368 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
367 ;;
369 ;;
368 3P)
370 3P)
369 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
371 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
370 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
372 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
371 ;;
373 ;;
372 4)
374 4)
373 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
375 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
374 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
376 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
375 ;;
377 ;;
376 *)
378 *)
377 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
379 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
378 exit 1
380 exit 1
379 ;;
381 ;;
380 esac
382 esac
381
383
382 # Raspberry PI 0,3,3P,4 with Bluetooth and Wifi onboard
384 # Raspberry PI 0,3,3P,4 with Bluetooth and Wifi onboard
383 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
385 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
384 ## Include bluetooth packages on supported boards
386 ## Include bluetooth packages on supported boards
385 if [ "$ENABLE_BLUETOOTH" = true ] ; then
387 if [ "$ENABLE_BLUETOOTH" = true ] ; then
386 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
388 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
387 fi
389 fi
388 if [ "$ENABLE_WIRELESS" = true ] ; then
390 if [ "$ENABLE_WIRELESS" = true ] ; then
389 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
391 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
390 fi
392 fi
391 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
393 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
392 else
394 else
393 ## Check if the internal wireless interface is not supported by the RPi model
395 ## Check if the internal wireless interface is not supported by the RPi model
394 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
396 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
395 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
397 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
396 exit 1
398 exit 1
397 fi
399 fi
398 fi
400 fi
399
401
400 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
402 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
401 echo "error: You have to compile kernel sources, if you want to enable nexmon"
403 echo "error: You have to compile kernel sources, if you want to enable nexmon"
402 exit 1
404 exit 1
403 fi
405 fi
404
406
405 # Prepare date string for default image file name
407 # Prepare date string for default image file name
406 DATE="$(date +%Y-%m-%d)"
408 DATE="$(date +%Y-%m-%d)"
407 if [ -z "$KERNEL_BRANCH" ] ; then
409 if [ -z "$KERNEL_BRANCH" ] ; then
408 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
410 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
409 else
411 else
410 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
412 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
411 fi
413 fi
412
414
413 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
415 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
414 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
416 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
415 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
417 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
416 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
418 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
417 exit 1
419 exit 1
418 fi
420 fi
419 fi
421 fi
420
422
421 # Add cmake to compile videocore sources
423 # Add cmake to compile videocore sources
422 if [ "$ENABLE_VIDEOCORE" = true ] ; then
424 if [ "$ENABLE_VIDEOCORE" = true ] ; then
423 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
425 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
424 fi
426 fi
425
427
426 # Add deps for nexmon
428 # Add deps for nexmon
427 if [ "$ENABLE_NEXMON" = true ] ; then
429 if [ "$ENABLE_NEXMON" = true ] ; then
428 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
430 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
429 fi
431 fi
430
432
431 # Add libncurses5 to enable kernel menuconfig
433 # Add libncurses5 to enable kernel menuconfig
432 if [ "$KERNEL_MENUCONFIG" = true ] ; then
434 if [ "$KERNEL_MENUCONFIG" = true ] ; then
433 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
435 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
434 fi
436 fi
435
437
436 # Add ccache compiler cache for (faster) kernel cross (re)compilation
438 # Add ccache compiler cache for (faster) kernel cross (re)compilation
437 if [ "$KERNEL_CCACHE" = true ] ; then
439 if [ "$KERNEL_CCACHE" = true ] ; then
438 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
440 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
439 fi
441 fi
440
442
441 # Add cryptsetup package to enable filesystem encryption
443 # Add cryptsetup package to enable filesystem encryption
442 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
444 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
443 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
445 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
444 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
446 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
445
447
446 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
448 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
447 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
449 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
448 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
450 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
449 fi
451 fi
450
452
451 if [ -z "$CRYPTFS_PASSWORD" ] ; then
453 if [ -z "$CRYPTFS_PASSWORD" ] ; then
452 echo "error: no password defined (CRYPTFS_PASSWORD)!"
454 echo "error: no password defined (CRYPTFS_PASSWORD)!"
453 exit 1
455 exit 1
454 fi
456 fi
455 ENABLE_INITRAMFS=true
457 ENABLE_INITRAMFS=true
456 fi
458 fi
457
459
458 # Add initramfs generation tools
460 # Add initramfs generation tools
459 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
461 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
460 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
462 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
461 fi
463 fi
462
464
463 # Add device-tree-compiler required for building the U-Boot bootloader
465 # Add device-tree-compiler required for building the U-Boot bootloader
464 if [ "$ENABLE_UBOOT" = true ] ; then
466 if [ "$ENABLE_UBOOT" = true ] ; then
465 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
467 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
466 fi
468 fi
467
469
468 if [ "$ENABLE_USBBOOT" = true ] ; then
470 if [ "$ENABLE_USBBOOT" = true ] ; then
469 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
471 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
470 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
472 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
471 exit 1
473 exit 1
472 fi
474 fi
473 fi
475 fi
474
476
475 # Check if root SSH (v2) public key file exists
477 # Check if root SSH (v2) public key file exists
476 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
478 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
477 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
479 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
478 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
480 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
479 exit 1
481 exit 1
480 fi
482 fi
481 fi
483 fi
482
484
483 # Check if $USER_NAME SSH (v2) public key file exists
485 # Check if $USER_NAME SSH (v2) public key file exists
484 if [ -n "$SSH_USER_PUB_KEY" ] ; then
486 if [ -n "$SSH_USER_PUB_KEY" ] ; then
485 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
487 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
486 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
488 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
487 exit 1
489 exit 1
488 fi
490 fi
489 fi
491 fi
490
492
491 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
493 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
492 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
494 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
493 exit 1
495 exit 1
494 fi
496 fi
495
497
496 # Check if all required packages are installed on the build system
498 # Check if all required packages are installed on the build system
497 for package in $REQUIRED_PACKAGES ; do
499 for package in $REQUIRED_PACKAGES ; do
498 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
500 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
499 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
501 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
500 fi
502 fi
501 done
503 done
502
504
503 # If there are missing packages ask confirmation for install, or exit
505 # If there are missing packages ask confirmation for install, or exit
504 if [ -n "$MISSING_PACKAGES" ] ; then
506 if [ -n "$MISSING_PACKAGES" ] ; then
505 echo "the following packages needed by this script are not installed:"
507 echo "the following packages needed by this script are not installed:"
506 echo "$MISSING_PACKAGES"
508 echo "$MISSING_PACKAGES"
507
509
508 printf "\ndo you want to install the missing packages right now? [y/n] "
510 printf "\ndo you want to install the missing packages right now? [y/n] "
509 read -r confirm
511 read -r confirm
510 [ "$confirm" != "y" ] && exit 1
512 [ "$confirm" != "y" ] && exit 1
511
513
512 ## Make sure all missing required packages are installed
514 ## Make sure all missing required packages are installed
513 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
515 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
514 fi
516 fi
515
517
516 # Check if ./bootstrap.d directory exists
518 # Check if ./bootstrap.d directory exists
517 if [ ! -d "./bootstrap.d/" ] ; then
519 if [ ! -d "./bootstrap.d/" ] ; then
518 echo "error: './bootstrap.d' required directory not found!"
520 echo "error: './bootstrap.d' required directory not found!"
519 exit 1
521 exit 1
520 fi
522 fi
521
523
522 # Check if ./files directory exists
524 # Check if ./files directory exists
523 if [ ! -d "./files/" ] ; then
525 if [ ! -d "./files/" ] ; then
524 echo "error: './files' required directory not found!"
526 echo "error: './files' required directory not found!"
525 exit 1
527 exit 1
526 fi
528 fi
527
529
528 # Check if specified KERNELSRC_DIR directory exists
530 # Check if specified KERNELSRC_DIR directory exists
529 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
531 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
530 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
532 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
531 exit 1
533 exit 1
532 fi
534 fi
533
535
534 # Check if specified UBOOTSRC_DIR directory exists
536 # Check if specified UBOOTSRC_DIR directory exists
535 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
537 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
536 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
538 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
537 exit 1
539 exit 1
538 fi
540 fi
539
541
540 # Check if specified VIDEOCORESRC_DIR directory exists
542 # Check if specified VIDEOCORESRC_DIR directory exists
541 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
543 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
542 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
544 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
543 exit 1
545 exit 1
544 fi
546 fi
545
547
546 # Check if specified FBTURBOSRC_DIR directory exists
548 # Check if specified FBTURBOSRC_DIR directory exists
547 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
549 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
548 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
550 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
549 exit 1
551 exit 1
550 fi
552 fi
551
553
552 # Check if specified NEXMONSRC_DIR directory exists
554 # Check if specified NEXMONSRC_DIR directory exists
553 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
555 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
554 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
556 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
555 exit 1
557 exit 1
556 fi
558 fi
557
559
558 # Check if specified CHROOT_SCRIPTS directory exists
560 # Check if specified CHROOT_SCRIPTS directory exists
559 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
561 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
560 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
562 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
561 exit 1
563 exit 1
562 fi
564 fi
563
565
564 # Check if specified device mapping already exists (will be used by cryptsetup)
566 # Check if specified device mapping already exists (will be used by cryptsetup)
565 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
567 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
566 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
568 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
567 exit 1
569 exit 1
568 fi
570 fi
569
571
570 # Don't clobber an old build
572 # Don't clobber an old build
571 if [ -e "$BUILDDIR" ] ; then
573 if [ -e "$BUILDDIR" ] ; then
572 echo "error: directory ${BUILDDIR} already exists, not proceeding"
574 echo "error: directory ${BUILDDIR} already exists, not proceeding"
573 exit 1
575 exit 1
574 fi
576 fi
575
577
576 # Setup chroot directory
578 # Setup chroot directory
577 mkdir -p "${R}"
579 mkdir -p "${R}"
578
580
579 # Check if build directory has enough of free disk space >512MB
581 # Check if build directory has enough of free disk space >512MB
580 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
582 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
581 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
583 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
582 exit 1
584 exit 1
583 fi
585 fi
584
586
585 set -x
587 set -x
586
588
587 # Call "cleanup" function on various signals and errors
589 # Call "cleanup" function on various signals and errors
588 trap cleanup 0 1 2 3 6
590 trap cleanup 0 1 2 3 6
589
591
590 # Add required packages for the minbase installation
592 # Add required packages for the minbase installation
591 if [ "$ENABLE_MINBASE" = true ] ; then
593 if [ "$ENABLE_MINBASE" = true ] ; then
592 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
594 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
593 fi
595 fi
594
596
595 # Add parted package, required to get partprobe utility
597 # Add parted package, required to get partprobe utility
596 if [ "$EXPANDROOT" = true ] ; then
598 if [ "$EXPANDROOT" = true ] ; then
597 APT_INCLUDES="${APT_INCLUDES},parted"
599 APT_INCLUDES="${APT_INCLUDES},parted"
598 fi
600 fi
599
601
600 # Add dphys-swapfile package, required to enable swap
602 # Add dphys-swapfile package, required to enable swap
601 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
603 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
602 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
604 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
603 fi
605 fi
604
606
605 # Add dbus package, recommended if using systemd
607 # Add dbus package, recommended if using systemd
606 if [ "$ENABLE_DBUS" = true ] ; then
608 if [ "$ENABLE_DBUS" = true ] ; then
607 APT_INCLUDES="${APT_INCLUDES},dbus"
609 APT_INCLUDES="${APT_INCLUDES},dbus"
608 fi
610 fi
609
611
610 # Add iptables IPv4/IPv6 package
612 # Add iptables IPv4/IPv6 package
611 if [ "$ENABLE_IPTABLES" = true ] ; then
613 if [ "$ENABLE_IPTABLES" = true ] ; then
612 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
614 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
613 fi
615 fi
614 # Add apparmor for KERNEL_SECURITY
616 # Add apparmor for KERNEL_SECURITY
615 if [ "$KERNEL_SECURITY" = true ] ; then
617 if [ "$KERNEL_SECURITY" = true ] ; then
616 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
618 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
617 fi
619 fi
618
620
619 # Add openssh server package
621 # Add openssh server package
620 if [ "$SSH_ENABLE" = true ] ; then
622 if [ "$SSH_ENABLE" = true ] ; then
621 APT_INCLUDES="${APT_INCLUDES},openssh-server"
623 APT_INCLUDES="${APT_INCLUDES},openssh-server"
622 fi
624 fi
623
625
624 # Add alsa-utils package
626 # Add alsa-utils package
625 if [ "$ENABLE_SOUND" = true ] ; then
627 if [ "$ENABLE_SOUND" = true ] ; then
626 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
628 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
627 fi
629 fi
628
630
629 # Add rng-tools package
631 # Add rng-tools package
630 if [ "$ENABLE_HWRANDOM" = true ] ; then
632 if [ "$ENABLE_HWRANDOM" = true ] ; then
631 APT_INCLUDES="${APT_INCLUDES},rng-tools"
633 APT_INCLUDES="${APT_INCLUDES},rng-tools"
632 fi
634 fi
633
635
634 # Add fbturbo video driver
636 # Add fbturbo video driver
635 if [ "$ENABLE_FBTURBO" = true ] ; then
637 if [ "$ENABLE_FBTURBO" = true ] ; then
636 # Enable xorg package dependencies
638 # Enable xorg package dependencies
637 ENABLE_XORG=true
639 ENABLE_XORG=true
638 fi
640 fi
639
641
640 # Add user defined window manager package
642 # Add user defined window manager package
641 if [ -n "$ENABLE_WM" ] ; then
643 if [ -n "$ENABLE_WM" ] ; then
642 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
644 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
643
645
644 # Enable xorg package dependencies
646 # Enable xorg package dependencies
645 ENABLE_XORG=true
647 ENABLE_XORG=true
646 fi
648 fi
647
649
648 # Add xorg package
650 # Add xorg package
649 if [ "$ENABLE_XORG" = true ] ; then
651 if [ "$ENABLE_XORG" = true ] ; then
650 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
652 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
651 fi
653 fi
652
654
653 # Replace selected packages with smaller clones
655 # Replace selected packages with smaller clones
654 if [ "$ENABLE_REDUCE" = true ] ; then
656 if [ "$ENABLE_REDUCE" = true ] ; then
655 ## Add levee package instead of vim-tiny
657 ## Add levee package instead of vim-tiny
656 if [ "$REDUCE_VIM" = true ] ; then
658 if [ "$REDUCE_VIM" = true ] ; then
657 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
659 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
658 fi
660 fi
659
661
660 ## Add dropbear package instead of openssh-server
662 ## Add dropbear package instead of openssh-server
661 if [ "$REDUCE_SSHD" = true ] ; then
663 if [ "$REDUCE_SSHD" = true ] ; then
662 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
664 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
663 fi
665 fi
664 fi
666 fi
665
667
666 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
668 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
667 if [ "$ENABLE_SYSVINIT" = false ] ; then
669 if [ "$ENABLE_SYSVINIT" = false ] ; then
668 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
670 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
669 fi
671 fi
670
672
671 # Configure kernel sources if no KERNELSRC_DIR
673 # Configure kernel sources if no KERNELSRC_DIR
672 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
674 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
673 KERNELSRC_CONFIG=true
675 KERNELSRC_CONFIG=true
674 fi
676 fi
675
677
676 # Configure reduced kernel
678 # Configure reduced kernel
677 if [ "$KERNEL_REDUCE" = true ] ; then
679 if [ "$KERNEL_REDUCE" = true ] ; then
678 KERNELSRC_CONFIG=false
680 KERNELSRC_CONFIG=false
679 fi
681 fi
680
682
681 # Configure qemu compatible kernel
683 # Configure qemu compatible kernel
682 if [ "$ENABLE_QEMU" = true ] ; then
684 if [ "$ENABLE_QEMU" = true ] ; then
683 DTB_FILE=vexpress-v2p-ca15_a7.dtb
685 DTB_FILE=vexpress-v2p-ca15_a7.dtb
684 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
686 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
685 KERNEL_DEFCONFIG="vexpress_defconfig"
687 KERNEL_DEFCONFIG="vexpress_defconfig"
686 if [ "$KERNEL_MENUCONFIG" = false ] ; then
688 if [ "$KERNEL_MENUCONFIG" = false ] ; then
687 KERNEL_OLDDEFCONFIG=true
689 KERNEL_OLDDEFCONFIG=true
688 fi
690 fi
689 fi
691 fi
690
692
691 # Execute bootstrap scripts
693 # Execute bootstrap scripts
692 for SCRIPT in bootstrap.d/*.sh; do
694 for SCRIPT in bootstrap.d/*.sh; do
693 head -n 3 "$SCRIPT"
695 head -n 3 "$SCRIPT"
694 . "$SCRIPT"
696 . "$SCRIPT"
695 done
697 done
696
698
697 ## Execute custom bootstrap scripts
699 ## Execute custom bootstrap scripts
698 if [ -d "custom.d" ] ; then
700 if [ -d "custom.d" ] ; then
699 for SCRIPT in custom.d/*.sh; do
701 for SCRIPT in custom.d/*.sh; do
700 . "$SCRIPT"
702 . "$SCRIPT"
701 done
703 done
702 fi
704 fi
703
705
704 # Execute custom scripts inside the chroot
706 # Execute custom scripts inside the chroot
705 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
707 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
706 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
708 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
707 chroot_exec /bin/bash -x <<'EOF'
709 chroot_exec /bin/bash -x <<'EOF'
708 for SCRIPT in /chroot_scripts/* ; do
710 for SCRIPT in /chroot_scripts/* ; do
709 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
711 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
710 $SCRIPT
712 $SCRIPT
711 fi
713 fi
712 done
714 done
713 EOF
715 EOF
714 rm -rf "${R}/chroot_scripts"
716 rm -rf "${R}/chroot_scripts"
715 fi
717 fi
716
718
717 # Remove c/c++ build environment from the chroot
719 # Remove c/c++ build environment from the chroot
718 chroot_remove_cc
720 chroot_remove_cc
719
721
720 # Generate required machine-id
722 # Generate required machine-id
721 MACHINE_ID=$(dbus-uuidgen)
723 MACHINE_ID=$(dbus-uuidgen)
722 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
724 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
723 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
725 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
724
726
725 # APT Cleanup
727 # APT Cleanup
726 chroot_exec apt-get -y clean
728 chroot_exec apt-get -y clean
727 chroot_exec apt-get -y autoclean
729 chroot_exec apt-get -y autoclean
728 chroot_exec apt-get -y autoremove
730 chroot_exec apt-get -y autoremove
729
731
730 # Unmount mounted filesystems
732 # Unmount mounted filesystems
731 umount -l "${R}/proc"
733 umount -l "${R}/proc"
732 umount -l "${R}/sys"
734 umount -l "${R}/sys"
733
735
734 # Clean up directories
736 # Clean up directories
735 rm -rf "${R}/run/*"
737 rm -rf "${R}/run/*"
736 rm -rf "${R}/tmp/*"
738 rm -rf "${R}/tmp/*"
737
739
738 # Clean up APT proxy settings
740 # Clean up APT proxy settings
739 if [ "$KEEP_APT_PROXY" = false ] ; then
741 if [ "$KEEP_APT_PROXY" = false ] ; then
740 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
742 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
741 fi
743 fi
742
744
743 # Clean up files
745 # Clean up files
744 rm -f "${ETC_DIR}/ssh/ssh_host_*"
746 rm -f "${ETC_DIR}/ssh/ssh_host_*"
745 rm -f "${ETC_DIR}/dropbear/dropbear_*"
747 rm -f "${ETC_DIR}/dropbear/dropbear_*"
746 rm -f "${ETC_DIR}/apt/sources.list.save"
748 rm -f "${ETC_DIR}/apt/sources.list.save"
747 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
749 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
748 rm -f "${ETC_DIR}/*-"
750 rm -f "${ETC_DIR}/*-"
749 rm -f "${ETC_DIR}/resolv.conf"
751 rm -f "${ETC_DIR}/resolv.conf"
750 rm -f "${R}/root/.bash_history"
752 rm -f "${R}/root/.bash_history"
751 rm -f "${R}/var/lib/urandom/random-seed"
753 rm -f "${R}/var/lib/urandom/random-seed"
752 rm -f "${R}/initrd.img"
754 rm -f "${R}/initrd.img"
753 rm -f "${R}/vmlinuz"
755 rm -f "${R}/vmlinuz"
754 rm -f "${R}${QEMU_BINARY}"
756 rm -f "${R}${QEMU_BINARY}"
755
757
756 if [ "$ENABLE_QEMU" = true ] ; then
758 if [ "$ENABLE_QEMU" = true ] ; then
757 # Setup QEMU directory
759 # Setup QEMU directory
758 mkdir "${BASEDIR}/qemu"
760 mkdir "${BASEDIR}/qemu"
759
761
760 # Copy kernel image to QEMU directory
762 # Copy kernel image to QEMU directory
761 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
763 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
762
764
763 # Copy kernel config to QEMU directory
765 # Copy kernel config to QEMU directory
764 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
766 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
765
767
766 # Copy kernel dtbs to QEMU directory
768 # Copy kernel dtbs to QEMU directory
767 for dtb in "${BOOT_DIR}/"*.dtb ; do
769 for dtb in "${BOOT_DIR}/"*.dtb ; do
768 if [ -f "${dtb}" ] ; then
770 if [ -f "${dtb}" ] ; then
769 install_readonly "${dtb}" "${BASEDIR}/qemu/"
771 install_readonly "${dtb}" "${BASEDIR}/qemu/"
770 fi
772 fi
771 done
773 done
772
774
773 # Copy kernel overlays to QEMU directory
775 # Copy kernel overlays to QEMU directory
774 if [ -d "${BOOT_DIR}/overlays" ] ; then
776 if [ -d "${BOOT_DIR}/overlays" ] ; then
775 # Setup overlays dtbs directory
777 # Setup overlays dtbs directory
776 mkdir "${BASEDIR}/qemu/overlays"
778 mkdir "${BASEDIR}/qemu/overlays"
777
779
778 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
780 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
779 if [ -f "${dtb}" ] ; then
781 if [ -f "${dtb}" ] ; then
780 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
782 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
781 fi
783 fi
782 done
784 done
783 fi
785 fi
784
786
785 # Copy u-boot files to QEMU directory
787 # Copy u-boot files to QEMU directory
786 if [ "$ENABLE_UBOOT" = true ] ; then
788 if [ "$ENABLE_UBOOT" = true ] ; then
787 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
789 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
788 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
790 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
789 fi
791 fi
790 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
792 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
791 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
793 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
792 fi
794 fi
793 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
795 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
794 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
796 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
795 fi
797 fi
796 fi
798 fi
797
799
798 # Copy initramfs to QEMU directory
800 # Copy initramfs to QEMU directory
799 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
801 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
800 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
802 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
801 fi
803 fi
802 fi
804 fi
803
805
804 # Calculate size of the chroot directory in KB
806 # Calculate size of the chroot directory in KB
805 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
807 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
806
808
807 # Calculate the amount of needed 512 Byte sectors
809 # Calculate the amount of needed 512 Byte sectors
808 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
810 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
809 FRMW_SECTORS=$(expr 128 \* 1024 \* 1024 \/ 512)
811 FRMW_SECTORS=$(expr 128 \* 1024 \* 1024 \/ 512)
810 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
812 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
811
813
812 # The root partition is EXT4
814 # The root partition is EXT4
813 # This means more space than the actual used space of the chroot is used.
815 # This means more space than the actual used space of the chroot is used.
814 # As overhead for journaling and reserved blocks 35% are added.
816 # As overhead for journaling and reserved blocks 35% are added.
815 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
817 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
816
818
817 # Calculate required image size in 512 Byte sectors
819 # Calculate required image size in 512 Byte sectors
818 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
820 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
819
821
820 # Prepare image file
822 # Prepare image file
821 if [ "$ENABLE_SPLITFS" = true ] ; then
823 if [ "$ENABLE_SPLITFS" = true ] ; then
822 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
824 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
823 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
825 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
824 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
826 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
825 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
827 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
826
828
827 ## Write firmware/boot partition tables
829 ## Write firmware/boot partition tables
828 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
830 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
829 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
831 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
830 EOM
832 EOM
831
833
832 ## Write root partition table
834 ## Write root partition table
833 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
835 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
834 ${TABLE_SECTORS},${ROOT_SECTORS},83
836 ${TABLE_SECTORS},${ROOT_SECTORS},83
835 EOM
837 EOM
836
838
837 # Setup temporary loop devices
839 # Setup temporary loop devices
838 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME"-frmw.img)"
840 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME"-frmw.img)"
839 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
841 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
840 # ENABLE_SPLITFS=false
842 # ENABLE_SPLITFS=false
841 else
843 else
842 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
844 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
843 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
845 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
844
846
845 # Write partition table
847 # Write partition table
846 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
848 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
847 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
849 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
848 ${ROOT_OFFSET},${ROOT_SECTORS},83
850 ${ROOT_OFFSET},${ROOT_SECTORS},83
849 EOM
851 EOM
850
852
851 # Setup temporary loop devices
853 # Setup temporary loop devices
852 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME".img)"
854 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME".img)"
853 ROOT_LOOP="$(losetup -o 129M -f --show "$IMAGE_NAME".img)"
855 ROOT_LOOP="$(losetup -o 129M -f --show "$IMAGE_NAME".img)"
854 fi
856 fi
855
857
856 if [ "$ENABLE_CRYPTFS" = true ] ; then
858 if [ "$ENABLE_CRYPTFS" = true ] ; then
857 # Create dummy ext4 fs
859 # Create dummy ext4 fs
858 mkfs.ext4 "$ROOT_LOOP"
860 mkfs.ext4 "$ROOT_LOOP"
859
861
860 # Setup password keyfile
862 # Setup password keyfile
861 touch .password
863 touch .password
862 chmod 600 .password
864 chmod 600 .password
863 echo -n ${CRYPTFS_PASSWORD} > .password
865 echo -n ${CRYPTFS_PASSWORD} > .password
864
866
865 # Initialize encrypted partition
867 # Initialize encrypted partition
866 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
868 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
867
869
868 # Open encrypted partition and setup mapping
870 # Open encrypted partition and setup mapping
869 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
871 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
870
872
871 # Secure delete password keyfile
873 # Secure delete password keyfile
872 shred -zu .password
874 shred -zu .password
873
875
874 # Update temporary loop device
876 # Update temporary loop device
875 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
877 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
876
878
877 # Wipe encrypted partition (encryption cipher is used for randomness)
879 # Wipe encrypted partition (encryption cipher is used for randomness)
878 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
880 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
879 fi
881 fi
880
882
881 # Build filesystems
883 # Build filesystems
882 mkfs.vfat "$FRMW_LOOP"
884 mkfs.vfat "$FRMW_LOOP"
883 mkfs.ext4 "$ROOT_LOOP"
885 mkfs.ext4 "$ROOT_LOOP"
884
886
885 # Mount the temporary loop devices
887 # Mount the temporary loop devices
886 mkdir -p "$BUILDDIR/mount"
888 mkdir -p "$BUILDDIR/mount"
887 mount "$ROOT_LOOP" "$BUILDDIR/mount"
889 mount "$ROOT_LOOP" "$BUILDDIR/mount"
888
890
889 mkdir -p "$BUILDDIR/mount/boot/firmware"
891 mkdir -p "$BUILDDIR/mount/boot/firmware"
890 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
892 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
891
893
892 # Copy all files from the chroot to the loop device mount point directory
894 # Copy all files from the chroot to the loop device mount point directory
893 rsync -a "${R}/" "$BUILDDIR/mount/"
895 rsync -a "${R}/" "$BUILDDIR/mount/"
894
896
895 # Unmount all temporary loop devices and mount points
897 # Unmount all temporary loop devices and mount points
896 cleanup
898 cleanup
897
899
898 # Create block map file(s) of image(s)
900 # Create block map file(s) of image(s)
899 if [ "$ENABLE_SPLITFS" = true ] ; then
901 if [ "$ENABLE_SPLITFS" = true ] ; then
900 # Create block map files for "bmaptool"
902 # Create block map files for "bmaptool"
901 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
903 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
902 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
904 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
903
905
904 # Image was successfully created
906 # Image was successfully created
905 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
907 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
906 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
908 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
907 else
909 else
908 # Create block map file for "bmaptool"
910 # Create block map file for "bmaptool"
909 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
911 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
910
912
911 # Image was successfully created
913 # Image was successfully created
912 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
914 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
913
915
914 # Create qemu qcow2 image
916 # Create qemu qcow2 image
915 if [ "$ENABLE_QEMU" = true ] ; then
917 if [ "$ENABLE_QEMU" = true ] ; then
916 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
918 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
917 QEMU_SIZE=16G
919 QEMU_SIZE=16G
918
920
919 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
921 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
920 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
922 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
921
923
922 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
924 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
923 fi
925 fi
924 fi
926 fi
1 NO CONTENT: file was removed, binary diff hidden
NO CONTENT: file was removed, binary diff hidden
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant